diff --git a/plugins/mmanon/mmanon.c b/plugins/mmanon/mmanon.c
index 5727b7db20..f47786550d 100644
--- a/plugins/mmanon/mmanon.c
+++ b/plugins/mmanon/mmanon.c
@@ -37,6 +37,8 @@
 #include "module-template.h"
 #include "errmsg.h"
 #include "parserif.h"
+#include "hashtable.h"
+
 
 
 MODULE_TYPE_OUTPUT
@@ -63,18 +65,30 @@ union node {
 	} ips;
 };
 
-
+struct ipv6_int {
+	unsigned long long high;
+	unsigned long long low;
+	};
 /* define operation modes we have */
 #define SIMPLE_MODE 0	 /* just overwrite */
 #define REWRITE_MODE 1	 /* rewrite IP address, canoninized */
 typedef struct _instanceData {
 	struct {
+		sbool enable;
 		int8_t bits;
 		union node* Root;
 		int randConsis;
 		enum mode mode;
 		uchar replaceChar;
 	} ipv4;
+
+	struct {
+		sbool enable;
+		uint8_t bits;
+		enum mode anonmode;
+		int randConsis;
+		struct hashtable* hash;
+	} ipv6;
 } instanceData;
 
 typedef struct wrkrInstanceData {
@@ -91,11 +105,15 @@ static modConfData_t *runModConf = NULL;/* modConf ptr to use for the current ex
 /* tables for interfacing with the v6 config system */
 /* action (instance) parameters */
 static struct cnfparamdescr actpdescr[] = {
+	{ "ipv4.enable", eCmdHdlrBinary, 0 },
 	{ "ipv4.mode", eCmdHdlrGetWord, 0 },
 	{ "mode", eCmdHdlrGetWord, 0 },
 	{ "ipv4.bits", eCmdHdlrPositiveInt, 0 },
 	{ "ipv4.replacechar", eCmdHdlrGetChar, 0},
-	{ "replacementchar", eCmdHdlrGetChar, 0}
+	{ "replacementchar", eCmdHdlrGetChar, 0},
+	{ "ipv6.enable", eCmdHdlrBinary, 0 },
+	{ "ipv6.anonmode", eCmdHdlrGetWord, 0 },
+	{ "ipv6.bits", eCmdHdlrPositiveInt, 0 }
 };
 static struct cnfparamblk actpblk =
 	{ CNFPARAMBLK_VERSION,
@@ -160,6 +178,9 @@ delTree(union node* node, const int layer)
 BEGINfreeInstance
 CODESTARTfreeInstance
 	delTree(pData->ipv4.Root, 0);
+	if(pData->ipv6.hash != NULL) {
+		hashtable_destroy(pData->ipv6.hash, 1);
+	}
 ENDfreeInstance
 
 
@@ -171,11 +192,18 @@ ENDfreeWrkrInstance
 static inline void
 setInstParamDefaults(instanceData *pData)
 {
+		pData->ipv4.enable = 1;
 		pData->ipv4.bits = 16;
 		pData->ipv4.Root = NULL;
 		pData->ipv4.randConsis = 0;
 		pData->ipv4.mode = ZERO;
 		pData->ipv4.replaceChar = 'x';
+
+		pData->ipv6.enable = 1;
+		pData->ipv6.bits = 96;
+		pData->ipv6.anonmode = ZERO;
+		pData->ipv6.randConsis = 0;
+		pData->ipv6.hash = NULL;
 }
 
 BEGINnewActInst
@@ -211,20 +239,47 @@ CODESTARTnewActInst
 					 sizeof("random-consistent")-1)) {
 				pData->ipv4.mode = RANDOMINT;
 				pData->ipv4.randConsis = 1;
+			} else {
+				parser_errmsg("mmanon: configuration error, unknown option for ipv4.mode, will use \"zero\"\n");
 			}
 		} else if(!strcmp(actpblk.descr[i].name, "ipv4.bits")) {
 			if((int8_t) pvals[i].val.d.n <= 32) {
 				pData->ipv4.bits = (int8_t) pvals[i].val.d.n;
 			} else {
 				pData->ipv4.bits = 32;
-				parser_errmsg("warning: invalid number of ipv4.bits (%d), corrected to 32", (int8_t) pvals[i].val.d.n);
+				parser_errmsg("warning: invalid number of ipv4.bits (%d), corrected to 32", (int) pvals[i].val.d.n);
 			}
+		} else if(!strcmp(actpblk.descr[i].name, "ipv4.enable")) {
+			pData->ipv4.enable = (int) pvals[i].val.d.n;
 		} else if(!strcmp(actpblk.descr[i].name, "ipv4.replacechar") || !strcmp(actpblk.descr[i].name, "replacementchar")) {
 			uchar* tmp = (uchar*) es_str2cstr(pvals[i].val.d.estr, NULL);
 			pData->ipv4.replaceChar = tmp[0];
 			free(tmp);
+		} else if(!strcmp(actpblk.descr[i].name, "ipv6.enable")) {
+			pData->ipv6.enable = (int) pvals[i].val.d.n;
+		} else if(!strcmp(actpblk.descr[i].name, "ipv6.bits")) {
+			if((uint8_t) pvals[i].val.d.n <= 128) {
+				pData->ipv6.bits = (uint8_t) pvals[i].val.d.n;
+			} else {
+				pData->ipv6.bits = 128;
+				parser_errmsg("warning: invalid number of ipv6.bits (%d), corrected to 128", (int) pvals[i].val.d.n);
+			}
+		} else if(!strcmp(actpblk.descr[i].name, "ipv6.anonmode")) {
+			if(!es_strbufcmp(pvals[i].val.d.estr, (uchar*)"zero",
+					 sizeof("zero")-1)) {
+				pData->ipv6.anonmode = ZERO;
+			} else if(!es_strbufcmp(pvals[i].val.d.estr, (uchar*)"random",
+					 sizeof("random")-1)) {
+				pData->ipv6.anonmode = RANDOMINT;
+			} else if(!es_strbufcmp(pvals[i].val.d.estr, (uchar*)"random-consistent",
+					 sizeof("random-consistent")-1)) {
+				pData->ipv6.anonmode = RANDOMINT;
+				pData->ipv6.randConsis = 1;
+			} else {
+				parser_errmsg("mmanon: configuration error, unknown option for ipv6.anonmode, will use \"zero\"\n");
+			}
 		} else {
-			dbgprintf("program error, non-handled "
+			parser_errmsg("mmanon: program error, non-handled "
 			  "param '%s'\n", actpblk.descr[i].name);
 		}
 	}
@@ -266,6 +321,22 @@ BEGINtryResume
 CODESTARTtryResume
 ENDtryResume
 
+
+static int
+getHexVal(char c)
+{
+	if('0' <= c && c <= '9') {
+		return c - '0';
+	} else if('a' <= c && c <= 'f') {
+		return (c - 'a') + 10;
+	} else if('A' <= c && c <= 'F') {
+		return (c - 'A') + 10;
+	} else {
+		return -1;
+	}
+}
+
+
 /* returns -1 if no integer found, else integer */
 static int64_t
 getPosInt(const uchar *const __restrict__ buf,
@@ -302,28 +373,33 @@ syntax_ipv4(const uchar *const __restrict__ buf,
 	if(val < 0 || val > 255)
 		goto done;
 
-	if(buf[i] != '.') goto done;
+	if(i >= buflen || buf[i] != '.') {
+		goto done;
+	}
 	i++;
 	val = getPosInt(buf+i, buflen-i, &nproc);
 	if(val < 0 || val > 255)
 		goto done;
 	i += nproc;
 
-	if(buf[i] != '.') goto done;
+	if(i >= buflen || buf[i] != '.') {
+		goto done;
+	}
 	i++;
 	val = getPosInt(buf+i, buflen-i, &nproc);
 	if(val < 0 || val > 255)
 		goto done;
 	i += nproc;
 
-	if(buf[i] != '.') goto done;
+	if(i >= buflen || buf[i] != '.') {
+		goto done;
+	}
 	i++;
 	val = getPosInt(buf+i, buflen-i, &nproc);
 	if(val < 0 || val > 255)
 		goto done;
 	i += nproc;
 
-	//printf("IP Addr[%zd]: '%s'\n", i, buf);
 	*nprocessed = i;
 	r = 1;
 
@@ -331,6 +407,126 @@ syntax_ipv4(const uchar *const __restrict__ buf,
 	return r;
 }
 
+
+static int
+isValidHexNum(const uchar *const __restrict__ buf,
+	const size_t buflen,
+	size_t *const __restrict__ nprocessed)
+{
+	size_t idx = 0;
+	int cyc = 0;
+
+	while(idx < buflen) {
+		switch(buf[idx]) {
+		case '0':
+		case '1':
+		case '2':
+		case '3':
+		case '4':
+		case '5':
+		case '6':
+		case '7':
+		case '8':
+		case '9':
+
+		case 'a':
+		case 'b':
+		case 'c':
+		case 'd':
+		case 'e':
+		case 'f':
+
+		case 'A':
+		case 'B':
+		case 'C':
+		case 'D':
+		case 'E':
+		case 'F':
+			cyc++;
+			if(cyc == 5) {
+				return 0;
+			}
+			(*nprocessed)++;
+			break;
+		case ':':
+			if(cyc == 0) {
+				(*nprocessed)++;
+				return -1;
+			}
+		default:
+			return cyc;
+		}
+		idx++;
+	}
+	return cyc;
+}
+
+
+static int
+syntax_ipv6(const uchar *const __restrict__ buf,
+	const size_t buflen,
+	size_t *const __restrict__ nprocessed)
+{
+	int lastSep = 0;
+	sbool hadAbbrev = 0;
+	sbool lastAbbrev = 0;
+	int ipParts = 0;
+	int numLen;
+	int isIP = 0;
+
+	while(*nprocessed < buflen) {
+		numLen = isValidHexNum(buf + *nprocessed, buflen - *nprocessed, nprocessed);
+		if(numLen > 0) {  //found a valid num
+			if((ipParts == 7 && hadAbbrev) || ipParts > 7) {
+				isIP = 0;
+				goto done;
+			}
+			if (ipParts == 0 && lastSep && !hadAbbrev) {
+				isIP = 0;
+				goto done;
+			}
+			lastSep = 0;
+			lastAbbrev = 0;
+			ipParts++;
+		} else if (numLen < 0) {  //':'
+			if(lastSep) {
+				if(hadAbbrev) {
+					isIP = 0;
+					goto done;
+				} else {
+					hadAbbrev = 1;
+					lastAbbrev = 1;
+				}
+			}
+			lastSep = 1;
+		} else {  //no valid num
+			if(lastSep) {
+				if(lastAbbrev && ipParts < 8) {
+					isIP = 1;
+					goto done;
+				}
+				isIP = 0;
+				goto done;
+			}
+			if((ipParts == 8 && !hadAbbrev) || (ipParts < 8 && hadAbbrev)) {
+				isIP = 1;
+				goto done;
+			} else {
+				isIP = 0;
+				goto done;
+			}
+		}
+	}
+
+	if((!lastSep && (ipParts == 8 && !hadAbbrev)) || (ipParts < 8 && hadAbbrev)) {
+		isIP = 1;
+	}
+
+done:
+	return isIP;
+}
+
+
 static unsigned
 ipv42num(const char *str)
 {
@@ -339,7 +535,7 @@ ipv42num(const char *str)
 	size_t len = strlen(str);
 	int cyc = 0;
 	for(unsigned i = 0 ; i < len ; i++) {
-		switch(str[i]){
+		switch(str[i]) {
 		case '0':
 		case '1':
 		case '2':
@@ -368,7 +564,7 @@ code_int(unsigned ip, instanceData *pData){
 	unsigned random;
 	unsigned long long shiftIP_subst = ip;
 	// variable needed because shift operation of 32nd bit in unsigned does not work
-	switch(pData->ipv4.mode){
+	switch(pData->ipv4.mode) {
 	case ZERO:
 		shiftIP_subst = ((shiftIP_subst>>(pData->ipv4.bits))<<(pData->ipv4.bits));
 		return (unsigned)shiftIP_subst;
@@ -399,9 +595,10 @@ num2ipv4(unsigned num, char *str) {
 
 
 static void
-getipv4(uchar *start, size_t end, char *address)
+getip(uchar *start, size_t end, char *address)
 {
 	size_t i;
+
 	for(i = 0; i < end; i++){
 		address[i] = *(start+i);
 	}
@@ -512,8 +709,9 @@ anonipv4(instanceData *pData, uchar **msg, int *pLenMsg, int *idx, int *hasChang
 			return;
 		}
 
-		getipv4(*msg + offset, iplen, address);
-		offset = offset + iplen; //iplen includes the character on offset
+		assert(iplen < sizeof(address));
+		getip(*msg + offset, iplen, address);
+		offset += iplen;
 		strcpy(caddress, address);
 		process_IPv4(caddress, pData);
 		caddresslen = strlen(caddress);
@@ -536,6 +734,270 @@ anonipv4(instanceData *pData, uchar **msg, int *pLenMsg, int *idx, int *hasChang
 }
 
 
+static void
+code_ipv6_int(struct ipv6_int* ip, instanceData *pData)
+{
+	unsigned long long randlow = 0;
+	unsigned long long randhigh = 0;
+	unsigned tmpRand;
+	int fullbits;
+
+	if(pData->ipv6.bits == 128) { //has to be handled separately, since shift 128 bits doesn't work on unsigned long long
+		ip->high = 0;
+		ip->low = 0;
+	} else if(pData->ipv6.bits > 64) {
+		ip->low = 0;
+		ip->high = (ip->high >> (pData->ipv6.bits - 64)) <<  (pData->ipv6.bits - 64);
+	} else if(pData->ipv6.bits == 64) {
+		ip->low = 0;			
+	} else {
+		ip->low = (ip->low >> pData->ipv6.bits) << pData->ipv6.bits;			
+	}
+	switch(pData->ipv6.anonmode) {
+	case ZERO:
+		break;
+	case RANDOMINT:
+		if(pData->ipv6.bits == 128) {
+			for(int i = 0; i < 8; i++) {
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				ip->high <<= 8;
+				ip->high |= tmpRand;
+
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				ip->low <<= 8;
+				ip->low |= tmpRand;
+			}
+		} else if(pData->ipv6.bits > 64) {
+			for(int i = 0; i < 8; i++) {
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				ip->low <<= 8;
+				ip->low |= tmpRand;
+			}
+
+			pData->ipv6.bits -= 64;
+			fullbits = pData->ipv6.bits / 8;
+			pData->ipv6.bits = pData->ipv6.bits % 8;
+			while(fullbits > 0) {
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				randhigh <<= 8;
+				randhigh |= tmpRand;
+				fullbits--;
+			}
+			tmpRand = (unsigned)((rand()/(double)RAND_MAX)*((1 << pData->ipv6.bits) - 1));
+			randhigh <<= pData->ipv6.bits;
+			randhigh |= tmpRand;
+
+			ip->high |= randhigh;
+		} else if(pData->ipv6.bits == 64) {
+			for(int i = 0; i < 8; i++) {
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				ip->low <<= 8;
+				ip->low |= tmpRand;
+			}
+		} else {
+			fullbits = pData->ipv6.bits / 8;
+			pData->ipv6.bits = pData->ipv6.bits % 8;
+			while(fullbits > 0) {
+				tmpRand = (unsigned)((rand()/(double)RAND_MAX)*0xff);
+				randlow <<= 8;
+				randlow |= tmpRand;
+				fullbits--;
+			}
+			tmpRand = (unsigned)((rand()/(double)RAND_MAX)*((1 << pData->ipv6.bits) - 1));
+			randlow <<= pData->ipv6.bits;
+			randlow |= tmpRand;
+
+			ip->low |= randlow;
+		}
+		break;
+	case SIMPLE:  //can't happen, since this case is caught at the start of anonipv4()
+	default:
+		LogError(0, RS_RET_INTERNAL_ERROR, "mmanon: unexpected code path reached in code_int function");
+	}
+}
+
+
+static struct ipv6_int* //separate function from recognising ipv6, since the recognition might get more
+ipv62num(char* address, size_t iplen)  //complex. This function always stays the same, since it
+					//always gets an valid ipv6 input
+{
+	struct ipv6_int* ip = (struct ipv6_int*) calloc(1, sizeof(struct ipv6_int));
+	int num[8] = {0, 0, 0, 0, 0, 0, 0, 0};
+	int cyc = 0;
+	int dots = 0;
+	int val;
+	unsigned i;
+
+	for(i = 0; i < iplen && dots < 2; i++) {
+		val = getHexVal(address[i]);
+		if(val == -1) {
+			dots++;
+			if(dots < 2) {
+				cyc++;
+			}
+		} else {
+			num[cyc] = num[cyc] * 16 + val;
+			dots = 0;
+		}
+	}
+	if(dots == 2) {
+		if(i < iplen - 1) {
+			int shift = 0;
+			cyc = 7;
+			for(unsigned j = iplen - 1; j >= i; j--) {
+				val = getHexVal(address[j]);
+				if(val == -1) {
+					cyc--;
+					shift = 0;
+				} else {
+					val <<= shift;
+					shift += 4;
+					num[cyc] += val;
+				}
+			}
+		} else {
+			while(cyc < 8) {
+				num[cyc] = 0;
+				cyc++;
+			}
+		}
+	}
+
+	for(i = 0; i < 4; i++) {
+		ip->high <<= 16;
+		ip->high |= num[i];
+	}
+	while(i < 8) {
+		ip->low <<= 16;
+		ip->low |= num[i];
+		i++;
+	}
+
+	return ip;
+}
+
+
+static void
+num2ipv6 (struct ipv6_int* ip, char* address)
+{
+	int num[8];
+	int i;
+
+	for(i = 7; i > 3; i--) {
+		num[i] = ip->low & 0xffff;
+		ip->low >>= 16;
+	}
+	while(i > -1) {
+		num[i] = ip->high & 0xffff;
+		ip->high >>= 16;
+		i--;
+	}
+
+	snprintf(address, 40, "%x:%x:%x:%x:%x:%x:%x:%x", num[0], num[1], num[2], num[3], num[4], num[5], num[6], num[7]);
+}
+
+
+static int
+keys_equal_fn(void* key1, void* key2)
+{
+	struct ipv6_int *const k1 = (struct ipv6_int*) key1;
+	struct ipv6_int *const k2 = (struct ipv6_int*) key2;
+
+	return((k1->high == k2->high) && (k1->low == k2->low))
+}
+
+
+static unsigned
+hash_from_key_fn (void* k)
+{
+	struct ipv6_int *const key = (struct ipv6_int*) k;
+	unsigned hashVal;
+
+	hashVal = (key->high & 0xFFC00000) | (key->low & 0x3FFFFF);
+	return hashVal;
+}
+
+
+static void
+findIPv6(struct ipv6_int* num, char* address, instanceData* pData)
+{
+	if(pData->ipv6.hash == NULL) {
+		pData->ipv6.hash = create_hashtable(512, hash_from_key_fn, keys_equal_fn, NULL);
+	}
+
+	char* val = (char*)(hashtable_search(pData->ipv6.hash, num));
+
+	if(val != NULL) {
+		strcpy(address, val);
+	} else {
+		struct ipv6_int* hashKey = (struct ipv6_int*) malloc(sizeof(struct ipv6_int));
+		hashKey->low = num->low;
+		hashKey->high = num->high;
+
+		code_ipv6_int(num, pData);
+		num2ipv6(num, address);
+		char* hashString = strdup(address);
+
+		hashtable_insert(pData->ipv6.hash, hashKey, hashString);
+	}
+}
+
+
+static void
+process_IPv6 (char* address, instanceData *pData, size_t iplen)
+{
+	struct ipv6_int* num;
+
+	num = ipv62num(address, iplen);
+
+	if(pData->ipv6.randConsis) {
+		findIPv6(num, address, pData);
+	} else {
+		code_ipv6_int(num, pData);
+		num2ipv6(num, address);
+	}
+	free(num);
+}
+
+
+static void
+anonipv6(instanceData *pData, uchar **msg, int *pLenMsg, int *idx, int *hasChanged)
+{
+	size_t iplen = 0;
+	int offset = *idx;
+	char address[40];
+	uchar* msgcpy = *msg;
+	unsigned caddresslen;
+	size_t oldLen = *pLenMsg;
+
+
+	int syn = syntax_ipv6(*msg + offset, *pLenMsg - offset, &iplen);
+	if(syn) {
+		assert(iplen < sizeof(address));
+		getip(*msg + offset, iplen, address);
+		offset += iplen;
+		process_IPv6(address, pData, iplen);
+
+		caddresslen = strlen(address);
+		*hasChanged = 1;
+
+		if(caddresslen != iplen) {
+			*pLenMsg = *pLenMsg + (caddresslen - iplen);
+			*msg = (uchar*) malloc(*pLenMsg);
+			memcpy(*msg, msgcpy, *idx);
+		}
+		memcpy(*msg + *idx, address, caddresslen);
+		*idx = *idx + caddresslen;
+		if(*idx < *pLenMsg) {
+			memcpy(*msg + *idx, msgcpy + offset, oldLen - offset);
+		}
+		if(msgcpy != *msg) {
+			free(msgcpy);
+		}
+	}
+}
+
+
 BEGINdoAction_NoStrings
 	smsg_t **ppMsg = (smsg_t **) pMsgData;
 	smsg_t *pMsg = ppMsg[0];
@@ -547,8 +1009,13 @@ CODESTARTdoAction
 	lenMsg = getMSGLen(pMsg);
 	msg = (uchar*)strdup((char*)getMSG(pMsg));
 
-	for(i = 0 ; i <= lenMsg - 7 ; ++i) {
-		anonipv4(pWrkrData->pData, &msg, &lenMsg, &i, &hasChanged);
+	for(i = 0 ; i <= lenMsg - 2 ; i++) {
+		if(pWrkrData->pData->ipv4.enable) {
+			anonipv4(pWrkrData->pData, &msg, &lenMsg, &i, &hasChanged);
+		}
+		if(pWrkrData->pData->ipv6.enable) {
+			anonipv6(pWrkrData->pData, &msg, &lenMsg, &i, &hasChanged);
+		}
 	}
 	if(hasChanged) {
 		MsgReplaceMSG(pMsg, msg, lenMsg);
@@ -588,6 +1055,7 @@ ENDqueryEtryPt
 
 BEGINmodInit()
 CODESTARTmodInit
+	srand(time(NULL));
 	*ipIFVersProvided = CURR_MOD_IF_VERSION; /* we only support the current interface specification */
 CODEmodInit_QueryRegCFSLineHdlr
 	DBGPRINTF("mmanon: module compiled with rsyslog version %s.\n", VERSION);
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 723f09c3f7..7e5cecf0cd 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -248,6 +248,14 @@ TESTS +=  \
 	mmanon_simple_12_ipv4.sh \
 	mmanon_simple_33_ipv4.sh \
 	mmanon_simple_8_ipv4.sh \
+	mmanon_random_128_ipv6.sh \
+	mmanon_zero_128_ipv6.sh \
+	mmanon_zero_96_ipv6.sh \
+	mmanon_random_cons_128_ipv6.sh \
+	mmanon_zero_50_ipv6.sh \
+	mmanon_recognize_ipv6.sh \
+	mmanon_zero_64_ipv6.sh \
+	mmanon_both_modes_compatible.sh \
 	empty-prop-comparison.sh \
 	rs_optimizer_pri.sh \
 	cee_simple.sh \
@@ -844,6 +852,14 @@ EXTRA_DIST= \
 	mmanon_simple_12_ipv4.sh \
 	mmanon_simple_33_ipv4.sh \
 	mmanon_simple_8_ipv4.sh \
+	mmanon_random_128_ipv6.sh \
+	mmanon_zero_128_ipv6.sh \
+	mmanon_zero_96_ipv6.sh \
+	mmanon_random_cons_128_ipv6.sh \
+	mmanon_zero_50_ipv6.sh \
+	mmanon_recognize_ipv6.sh \
+	mmanon_zero_64_ipv6.sh \
+	mmanon_both_modes_compatible.sh \
 	testsuites/rscript_ne_var.conf \
 	rscript_eq.sh \
 	testsuites/rscript_eq.conf \
diff --git a/tests/mmanon_both_modes_compatible.sh b/tests/mmanon_both_modes_compatible.sh
new file mode 100755
index 0000000000..4027c3ea51
--- /dev/null
+++ b/tests/mmanon_both_modes_compatible.sh
@@ -0,0 +1,35 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv4.enable="on" ipv4.mode="zero" ipv4.bits="32" ipv6.bits="128" ipv6.anonmode="zero" ipv6.enable="on")
+	action(type="omfile" file="rsyslog.out.log" template="outfmt")
+}'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 1.1.1.8 space 61:34:ad::7:F
+<129>Mar 10 01:00:00 172.20.245.8 tag: 111.1.1.8
+<129>Mar 10 01:00:00 172.20.245.8 tag: abf:3:002::500F:ce 1.1.1.9\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' 0:0:0:0:0:0:0:0
+ 0.0.0.0 space 0:0:0:0:0:0:0:0
+ 0.0.0.0
+ 0:0:0:0:0:0:0:0 0.0.0.0' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_random_128_ipv6.sh b/tests/mmanon_random_128_ipv6.sh
new file mode 100755
index 0000000000..901621ad7c
--- /dev/null
+++ b/tests/mmanon_random_128_ipv6.sh
@@ -0,0 +1,64 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+template(name="filename" type="string" string="rsyslog.out.%syslogtag%.log")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv6.anonmode="random" ipv6.bits="128" ipv6.enable="on")
+	action(type="omfile" dynafile="filename" template="outfmt")
+}'
+
+echo 'Since this test tests randomization, there is a theoretical possibility of it failing even if rsyslog works correctly. Therefore, if the test unexpectedly fails try restarting it.'
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 file1 33:45:DDD::4
+<129>Mar 10 01:00:00 172.20.245.8 file2 ::
+<129>Mar 10 01:00:00 172.20.245.8 file3 72:8374:adc7:47FF::43:0:1AFE
+<129>Mar 10 01:00:00 172.20.245.8 file4 FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 file5 72:8374:adc7:47FF::43:0:1AFE\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' 33:45:DDD::4' | cmp rsyslog.out.file1.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file1.log is:"
+  cat rsyslog.out.file1.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' ::' | cmp rsyslog.out.file2.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file2.log is:"
+  cat rsyslog.out.file2.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' 72:8374:adc7:47FF::43:0:1AFE' | cmp rsyslog.out.file3.log  >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file3.log is:"
+  cat rsyslog.out.file3.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF' | cmp rsyslog.out.file4.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file4.log is:"
+  cat rsyslog.out.file4.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+cmp rsyslog.out.file3.log rsyslog.out.file5.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-addresses generated, rsyslog.out.file3.log and rsyslog.out.file5.log are:"
+  cat rsyslog.out.file3.log
+  cat rsyslog.out.file5.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_random_cons_128_ipv6.sh b/tests/mmanon_random_cons_128_ipv6.sh
new file mode 100755
index 0000000000..7b4c28dd25
--- /dev/null
+++ b/tests/mmanon_random_cons_128_ipv6.sh
@@ -0,0 +1,81 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+template(name="filename" type="string" string="rsyslog.out.%syslogtag%.log")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv6.anonmode="random-consistent" ipv6.bits="128")
+	action(type="omfile" dynafile="filename" template="outfmt")
+}'
+
+echo 'Since this test tests randomization, there is a theoretical possibility of it failing even if rsyslog works correctly. Therefore, if the test unexpectedly fails try restarting it.'
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 file1 33:45:DDD::4
+<129>Mar 10 01:00:00 172.20.245.8 file2 ::
+<129>Mar 10 01:00:00 172.20.245.8 file6 ::
+<129>Mar 10 01:00:00 172.20.245.8 file3 72:8374:adc7:47FF::43:0:1AFE
+<129>Mar 10 01:00:00 172.20.245.8 file4 FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 file5 72:8374:adc7:47FF::43:0:1AFE\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' 33:45:DDD::4' | cmp rsyslog.out.file1.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file1.log is:"
+  cat rsyslog.out.file1.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' ::' | cmp rsyslog.out.file2.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file2.log is:"
+  cat rsyslog.out.file2.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' 72:8374:adc7:47FF::43:0:1AFE' | cmp rsyslog.out.file3.log  >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file3.log is:"
+  cat rsyslog.out.file3.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+echo ' FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF' | cmp rsyslog.out.file4.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-address generated, rsyslog.out.file4.log is:"
+  cat rsyslog.out.file4.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+cmp rsyslog.out.file3.log rsyslog.out.file5.log >/dev/null
+if [ ! $? -eq 0 ]; then
+  echo "invalidly unequal ip-addresses generated, rsyslog.out.file1.log and rsyslog.out.file6.log are:"
+  cat rsyslog.out.file1.log
+  cat rsyslog.out.file6.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+cmp rsyslog.out.file2.log rsyslog.out.file6.log >/dev/null
+if [ ! $? -eq 0 ]; then
+  echo "invalidly unequal ip-addresses generated, rsyslog.out.file1.log and rsyslog.out.file6.log are:"
+  cat rsyslog.out.file1.log
+  cat rsyslog.out.file6.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+cmp rsyslog.out.file4.log rsyslog.out.file5.log >/dev/null
+if [ $? -eq 0 ]; then
+  echo "invalidly equal ip-addresses generated, rsyslog.out.file4.log and rsyslog.out.file5.log are:"
+  cat rsyslog.out.file4.log
+  cat rsyslog.out.file5.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_recognize_ipv6.sh b/tests/mmanon_recognize_ipv6.sh
new file mode 100755
index 0000000000..83f438d753
--- /dev/null
+++ b/tests/mmanon_recognize_ipv6.sh
@@ -0,0 +1,59 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv4.enable="off" ipv6.enable="on" ipv6.bits="128" ipv6.anonmode="zero")
+	action(type="omfile" file="rsyslog.out.log" template="outfmt")
+}'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: asdfghjk
+<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 61:34:ad::7:F aa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: ::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 0::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45::. test
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45::* test
+<129>Mar 10 01:00:00 172.20.245.8 tag: *13:abd:45::* test
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:* test
+<129>Mar 10 01:00:00 172.20.245.8 tag: ewirnwemaa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: a::, cc:: LLL
+<129>Mar 10 01:00:00 172.20.245.8 tag: 12:12345::a
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFE
+<129>Mar 10 01:00:00 172.20.245.8 tag: 72:8374:adc7:47FF::43:0:1AFEstillnoblank
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFEstillnoblank\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' asdfghjk
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 13:abd:45:
+ 0:0:0:0:0:0:0:0. test
+ 0:0:0:0:0:0:0:0* test
+ *0:0:0:0:0:0:0:0* test
+ 13:abd:45:* test
+ ewirnwem0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0, 0:0:0:0:0:0:0:0 LLL
+ 12:10:0:0:0:0:0:0:0
+ textnoblank0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0stillnoblank
+ textnoblank0:0:0:0:0:0:0:0stillnoblank' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_zero_128_ipv6.sh b/tests/mmanon_zero_128_ipv6.sh
new file mode 100755
index 0000000000..52df24796f
--- /dev/null
+++ b/tests/mmanon_zero_128_ipv6.sh
@@ -0,0 +1,50 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv6.bits="129" ipv6.anonmode="zero")
+	action(type="omfile" file="./rsyslog.out.log" template="outfmt")
+}
+action(type="omfile" file="rsyslog2.out.log")'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: asdfghjk
+<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 61:34:ad::7:F aa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: ::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 0::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFEstillnoblank\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' asdfghjk
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 13:abd:45:
+ textnoblank0:0:0:0:0:0:0:0stillnoblank' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+
+grep 'invalid number of ipv6.bits (129), corrected to 128' rsyslog2.out.log > /dev/null
+if [ $? -ne 0 ]; then
+  echo "invalid correction of bits parameter generated, rsyslog2.out.log is:"
+  cat rsyslog2.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_zero_50_ipv6.sh b/tests/mmanon_zero_50_ipv6.sh
new file mode 100755
index 0000000000..b6a6c37811
--- /dev/null
+++ b/tests/mmanon_zero_50_ipv6.sh
@@ -0,0 +1,42 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv6.bits="50" ipv6.anonmode="zero")
+	action(type="omfile" file="./rsyslog.out.log" template="outfmt")
+}
+action(type="omfile" file="rsyslog2.out.log")'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: asdfghjk
+<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 61:34:ad::7:F aa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: ::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 0::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFEstillnoblank\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' asdfghjk
+ ffff:ffff:ffff:ffff:fffc:0:0:0
+ 61:34:ad:0:0:0:0:0 aa:ff43:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 13:abd:45:
+ textnoblank72:8374:adc7:47ff:0:0:0:0stillnoblank' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_zero_64_ipv6.sh b/tests/mmanon_zero_64_ipv6.sh
new file mode 100755
index 0000000000..94860d25ff
--- /dev/null
+++ b/tests/mmanon_zero_64_ipv6.sh
@@ -0,0 +1,41 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon" ipv6.bits="64" ipv6.anonmode="zero")
+	action(type="omfile" file="./rsyslog.out.log" template="outfmt")
+}'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: asdfghjk
+<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 61:34:ad::7:F aa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: ::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 0::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFEstillnoblank\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' asdfghjk
+ ffff:ffff:ffff:ffff:0:0:0:0
+ 61:34:ad:0:0:0:0:0 aa:ff43:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 13:abd:45:
+ textnoblank72:8374:adc7:47ff:0:0:0:0stillnoblank' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
diff --git a/tests/mmanon_zero_96_ipv6.sh b/tests/mmanon_zero_96_ipv6.sh
new file mode 100755
index 0000000000..7f9802f67d
--- /dev/null
+++ b/tests/mmanon_zero_96_ipv6.sh
@@ -0,0 +1,42 @@
+#!/bin/bash
+# add 2016-11-22 by Jan Gerhards, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+template(name="outfmt" type="string" string="%msg%\n")
+
+module(load="../plugins/mmanon/.libs/mmanon")
+module(load="../plugins/imtcp/.libs/imtcp")
+input(type="imtcp" port="13514" ruleset="testing")
+
+ruleset(name="testing") {
+	action(type="mmanon")
+	action(type="omfile" file="./rsyslog.out.log" template="outfmt")
+}
+action(type="omfile" file="rsyslog2.out.log")'
+
+. $srcdir/diag.sh startup
+. $srcdir/diag.sh tcpflood -m1 -M "\"<129>Mar 10 01:00:00 172.20.245.8 tag: asdfghjk
+<129>Mar 10 01:00:00 172.20.245.8 tag: FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF
+<129>Mar 10 01:00:00 172.20.245.8 tag: 61:34:ad::7:F aa:ff43::756:99:0
+<129>Mar 10 01:00:00 172.20.245.8 tag: ::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 0::
+<129>Mar 10 01:00:00 172.20.245.8 tag: 13:abd:45:
+<129>Mar 10 01:00:00 172.20.245.8 tag: textnoblank72:8374:adc7:47FF::43:0:1AFEstillnoblank\""
+
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo ' asdfghjk
+ ffff:ffff:0:0:0:0:0:0
+ 61:34:0:0:0:0:0:0 aa:ff43:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 0:0:0:0:0:0:0:0
+ 13:abd:45:
+ textnoblank72:8374:0:0:0:0:0:0stillnoblank' | cmp rsyslog.out.log
+if [ ! $? -eq 0 ]; then
+  echo "invalid response generated, rsyslog.out.log is:"
+  cat rsyslog.out.log
+  . $srcdir/diag.sh error-exit  1
+fi;
+
+. $srcdir/diag.sh exit
